#ifndef OUTPUT_CPP
#define OUTPUT_CPP

#include "basedef.h"
#include "base.cpp"
#include <fstream.h>
#include <string.h>

#define align_right 1
#define align_left 0

class output : public ofstream {
	int align;
	public:
		output(char* fname) : ofstream(fname) {}
		void set_align(int a) {align=a;}
		void put_num(dword val,int wd,int base=10);
		void put_flags(dword val,int wd);
		int put_str(char* str,int wd=0);
		void put_char(char c,int wd=1);
		void put_dir(rec_t type);
};

void output::put_dir(rec_t type) {
	operator << ('[');
	operator << (directive[type]);
	operator << (']') << endl;
}

void output::put_num(dword val,int wd,int base) {
	char s[33];
	int i=0;
	if (val==0) s[i++]='0';
	else
		while(val>0) {
			s[i++]=digit_to_char(val%base);
			val/=base;
		}
	if (align==align_right)
		put_char(' ',wd-i);
	for (int j=i;j>0;j--)
		operator << (s[j-1]);
	if (align==align_left)
		put_char(' ',wd-i);
}

void output::put_flags(dword val,int wd) {
	char* s=new char[wd];
	for (int i=0;i<wd;i++) {
		s[i]='0'+val%2;
		val/=2;
	}
	for (i=wd-1;i>=0;i--) {
		put(s[i]);
	}
	delete s;
}

int output::put_str(char* str,int wd) {
	if (str==NULL) str="";
	int len=strlen(str);
	if (align==align_right)
		put_char(' ',wd-len);
	operator << (str);
	if (align==align_left)
		put_char(' ',wd-len);
  return len;
}

void output::put_char(char c,int wd) {
	for (int i=0;i<wd;i++)
  	put(c);
}

#endif