#ifndef TABLE_CPP
#define TABLE_CPP

#include "basedef.h"
#include "error.h"
#include "base.cpp"
#include "record.cpp"
#include "input.cpp"
#include "output.cpp"
#include "globdata.cpp"

class Table {
	rec_t type;
	public:
		Table(rec_t t) : type(t) {}
		err_c load(input& in);
		void store(output& out);
};

err_c Table::load(input& in) {
	rec_t dir;
	if (in.get_dir(dir)) return DIRECTIVE_EXPECTED;
	if (dir!=type) return WRONG_DIRECTIVE;
	for (int i=0;i<rec_count[type];i++) {
		Record r(type,i);
		safe_call(r.load(in));
	}
  if (in.get_dir(dir) || dir!=rec_t_cnt) return END_EXPECTED;
	return NO_ERROR;
}

void Table::store(output& out) {
	out << endl;
	out.put_dir(type);
	int mnl=names[type]->max_len();
	int mll=labels[type]->max_len();
	for (int i=0;i<rec_count[type];i++) {
		Record r(type,i);
		r.store(out,mnl,mll);
	}
	out.put_dir(rec_t_cnt);
}

#endif